//--------------------------------------------------------------------------
//       
//   OUTDA()  KADR()
//    BC4.5    OWL2.0
//--------------------------------------------------------------------------

#include <owl\applicat.h>
#include <owl\framewin.h>
#include <owl\dialog.h>
#include <owl\edit.h>
#include <stdio.h>
#pragma hdrstop
#include "analog_i.rh"
#include "lcard_ad.h"



TEdit* DACEd;          //    
TStatic* ADCEdArray[16]; //     

//--------------------------------------------------------------------------
//     TMainDialog
//--------------------------------------------------------------------------
class TMainDialog:public TDialog {
public:
   TMainDialog(TWindow* parent, TResId resId);
protected:
   void wmTimer();
   void SetupWindow();
   ~TMainDialog();
   void EvTimer(uint timerId);
DECLARE_RESPONSE_TABLE(TMainDialog);
};

DEFINE_RESPONSE_TABLE1(TMainDialog, TDialog)
  EV_WM_TIMER,
END_RESPONSE_TABLE;

TMainDialog::TMainDialog(TWindow* parent, TResId resId)
   : TWindow((TWindow*)0), TDialog(Parent, resId)
{
   DACEd=new TEdit(this, ID_DACEd);
   for (int i=0; i<16; i++)
      ADCEdArray[i]=new TStatic(this, ID_ADCEd+i);
};

void TMainDialog::SetupWindow(void)
{
TDialog::SetupWindow();
SetTimer(ID_Timer, 100);
LOW_POWER(0);
};


TMainDialog::~TMainDialog(void)
{
KillTimer(ID_Timer);
};


void TMainDialog::EvTimer(uint timerId)
{
char S[80];
float rDAC;
int  j;
WORD Channels[16];
WORD Data[16];

   DACEd->GetText(S, sizeof(S));
   sscanf(S,"%f", &rDAC);
   OUTDA( rDAC/5.12*2047 );

   for (j=0; j<16; j++)
      Channels[j]=CREATE_CHANNEL(j,0,0);
   KADR(Data, Channels, 16);

   for (j=0; j<16; j++)
      {
      sprintf(S, "%4.2f", (int)Data[j]*5.12/2047, S);
      ADCEdArray[j]->SetText(S);
      };

};


//--------------------------------------------------------------------------
//   TMainApp
//--------------------------------------------------------------------------
class TMainApp: public TApplication {
public:
   TMainApp(const char far* name) :TApplication(name) {};
   void InitMainWindow();
};

void TMainApp::InitMainWindow()
{
   EnableBWCC();

   TMainDialog *cp;
   cp = new TMainDialog(0, ID_MAINDIALOG);

   MainWindow =
      new TFrameWindow(
         0,
         "   -",
         cp,
         TRUE);
   MainWindow->Attr.Style &= ~(WS_MAXIMIZEBOX | WS_THICKFRAME);
};

#pragma argsused
int OwlMain( int argc, char* argv[])
{
   TMainApp app("");
   return app.Run();
};

